

import os
import shutil

def CollectFiles(BaseDir, IncludeSubDir, ExtName)->list:
    FileList = []
    if os.path.isdir(BaseDir):
        for File in os.listdir(BaseDir):
            FullPath = os.path.join(BaseDir, File)
            if os.path.isdir(FullPath):
                if IncludeSubDir == True:
                    FileList = FileList + CollectFiles(FullPath, IncludeSubDir, ExtName)
            elif len(ExtName) < 1 or FullPath.endswith(ExtName):
                FileList.append(FullPath)

    return FileList


def DirectoryExist(FullDir):
    FullDir = FullDir.replace('\\', '/')
    return os.path.isdir(FullDir)


def Move(Src, Dest):
    Src = Src.replace('\\', '/')
    Dest = Dest.replace('\\', '/')
    if os.path.isfile(Src) or  os.path.isdir(Src):
        if not DirectoryExist(os.path.dirname(Dest)):
            CreateDirectoryTree(os.path.dirname(Dest))
        return shutil.move(Src, Dest)

    return False

def DeleteDirectory(FullDir):
    FullDir = FullDir.replace('\\', '/')
    if DirectoryExist(FullDir):
        return shutil.rmtree(FullDir)
    return True

def DeleteFile(FullPath):
    FullPath = FullPath.replace('\\', '/')
    if os.path.isfile(FullPath):
        return os.remove(FullPath)
    return False

def FileExist(FullPath):
    FullPath = FullPath.replace('\\', '/')
    return os.path.isfile(FullPath)

def IsEmptyDirectory(FullPath)->bool:
    FullPath = FullPath.replace('\\', '/')
    FileList = CollectFiles(FullPath, True, '')
    return len(FileList) < 1

def CopyFile(Src, Dest):
    Src = Src.replace('\\', '/')
    Dest = Dest.replace('\\', '/')
    if os.path.isfile(Src) or  os.path.isdir(Src):
        TargetDir = os.path.dirname(Dest)
        if(not DirectoryExist(TargetDir)):
            os.makedirs(TargetDir, exist_ok=True)
        return shutil.copy(Src, Dest)

    return False

def FileSize(FullPath)->int:
    FullPath = FullPath.replace('\\', '/')
    if (not FileExist(FullPath)):
        return 0
        
    return os.path.getsize(FullPath)


def CreateDirectoryTree(InFullDir):
    InFullDir = InFullDir.replace('\\', '/')
    if(not DirectoryExist(InFullDir)):
            os.makedirs(InFullDir, exist_ok=True)

            
def CopyDirectoryTree(InSrcDir, InDestDir):
    InSrcDir = InSrcDir.replace('\\', '/')
    InDestDir = InDestDir.replace('\\', '/')
    if DirectoryExist(InSrcDir) and not DirectoryExist(InDestDir):
        shutil.copytree(InSrcDir, InDestDir)
